## box64 0.3.8+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

cmake_policy(SET CMP0065 NEW)

SET(CMAKE_C_FLAGS_DEBUG  "-O0 -g")
SET(CMAKE_CXX_FLAGS_DEBUG  "-O0 -g")

option(RPI3ARM64 "Set to ON if targeting an RaspberryPI3 device with multiarch arm64 and armhf" ${RPI3ARM64})
option(RPI4ARM64 "Set to ON if targeting an RaspberryPI4 device with multiarch arm64 and armhf" ${RPI4ARM64})
option(RPI5ARM64 "Set to ON if targeting an RaspberryPi5 device with multiarch arm64 and armhf" ${RPI5ARM64})
option(RK3326 "Set to ON if targeting an Rockchip RK3326 based device" ${RK3326})
option(RK3399 "Set to ON if targeting an Rockchip RK3399 based device" ${RK3399})
option(RK3588 "Set to ON if targeting an Rockchip RK3588(S) based device" ${RK3588})
option(ODROIDN2 "Set to ON if targeting an Odroid-N2 device" ${ODROIDN2})
option(TEGRAX1 "Set to ON if targeting an Tegra X1 based device" ${TEGRAX1})
option(TEGRA_T194 "Set to ON if targeting an Tegra Xavier based device" ${TEGRA_T194})
option(TEGRA_T234 "Set to ON if targeting an Tegra Orin based device" ${TEGRA_T234})
option(PHYTIUM "Set to ON if targeting an Phytium (D2000 or FT2000/4) based device" ${PHYTIUM})
option(SD845 "Set to ON if targeting a Snapragon 845 based device" ${SD845})
option(SD865 "Set to ON if targeting a Snapragon 865 based device" ${SD865})
option(SD888 "Set to ON if targeting a Snapragon 888 based device" ${SD888})
option(SD8G2 "Set to ON if targeting a Snapragon 8 Gen 2 based device" ${SD8G2})
option(SDORYON1 "Set to ON if targeting a Snapdragon Oryon 1 (X1E80100/X1E78100) based device" ${SDORYON1})
option(ADLINK "Set to ON if targeting an ADLink AmpereAltra based device" ${ADLINK})
option(M1 "Set to ON if targeting a AppleM1 running on Asahi computer" ${M1})
option(LARCH64 "Set to ON if targeting an Loongarch64 based device" ${LARCH64})
option(RV64 "Set to ON if targeting an RISC-V RV64GC based device" ${RV64})
option(PPC64LE "Set to ON if targeting an PowerPC 64 LE based device" ${PPC64LE})
option(LX2160A "Set to ON if targeting an LX2160A based device" ${LX2160A})
option(ARM64 "Set to ON if targeting a generic ARM64 based device" ${ARM64})
option(ANDROID "Set to ON if targeting an Android device" ${ANDROID})
option(TERMUX "Set to ON if targeting an Android device with Termux" ${TERMUX})
option(WINLATOR_GLIBC "Set to ON if targeting an Android device with Winlator Glibc" ${WINLATOR_GLIBC})
option(USE_CCACHE "Set to ON to use ccache if present in the system" ${USE_CCACHE})
option(HAVE_TRACE "Set to ON to have Trace ability (needs libzydis-dev)" ${HAVE_TRACE})
option(ZYDIS3 "Set to ON if you have trace and an old libzydis v3.x" ${ZYDIS3})
option(SAVE_MEM "Set to ON to build dynarec with some slower memory saving optimizations" ${SAVE_MEM})
option(NOLOADADDR "Set to ON to avoid fixing the load address of Box64" OFF)
option(NOGIT "Set to ON if not building from a git clone repo (like when building from a zip download from github)" ${NOGIT})
option(BAD_SIGNAL "Set to ON to activate the workaround for incoherent si_info on SIGSEGV" ${BAD_SIGNAL})
option(SW64 "Set ON if targeting an SW64 based device" ${SW64})
option(CI "Set to ON if running in CI" ${CI})
option(WITH_MOLD "Set to ON to use with mold" ${WITH_MOLD})
option(BOX32 "Set to ON to add Linux 32bits support (experimental, do not use)" ${BOX32})
option(BOX32_BINFMT "Also setup binfmt integration for box32" ${BOX32_BINFMT})
option(LARCH64_ABI_1 "Set to ON if building for Loongarch64 ABI 1.0 system" ${LARCH64_ABI_1})
option(GDBJIT "Set to ON to enable GDB JIT support" ${GDBJIT})
option(WOW64 "Set to ON if you want a WOW64 PE build in addition")

if(TERMUX)
    set(TERMUX_PATH "/data/data/com.termux/files")
    set(ANDROID ON CACHE BOOL "")
endif()

# Hack: limit the optimization level to -O1 for some platforms
if(TERMUX OR ANDROID)
    set(CMAKE_C_FLAGS_RELEASE "-O1")
    set(CMAKE_CXX_FLAGS_RELEASE "-O1")
    set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O1 -g")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O1 -g")
endif()

if(LARCH64)
    set(LD80BITS OFF CACHE BOOL "")
    set(NOALIGN OFF CACHE BOOL "")
    set(ARM_DYNAREC OFF CACHE BOOL "")
    set(RV64_DYNAREC OFF CACHE BOOL "")
    set(LARCH64_DYNAREC ON CACHE BOOL "")
    if(LARCH64_ABI_1)
        message(STATUS "Build for Loongarch64 ABI 1.0 system")
        add_definitions(-DLA64_ABI_1)
    endif()
endif()
if(RV64)
    set(LD80BITS OFF CACHE BOOL "")
    set(NOALIGN OFF CACHE BOOL "")
    set(ARM_DYNAREC OFF CACHE BOOL "")
    set(RV64_DYNAREC ON CACHE BOOL "")
    set(LARCH64_DYNAREC OFF CACHE BOOL "")
endif()
if(PPC64LE)
    set(LD80BITS OFF CACHE BOOL "")
    set(NOALIGN OFF CACHE BOOL "")
    set(ARM_DYNAREC OFF CACHE BOOL "")
    set(RV64_DYNAREC OFF CACHE BOOL "")
    set(LARCH64_DYNAREC OFF CACHE BOOL "")
endif()
if(RK3399 OR RK3588 OR ODROIDN2 OR RPI3ARM64 OR RPI4ARM64 OR RPI5ARM64 OR RK3326 OR TEGRAX1 OR TEGRA_T194 OR TEGRA_T234 OR PHYTIUM OR SD845 OR SD865 OR SD888 OR SD8G2 OR SDORYON1 OR LX2160A OR M1 OR ARM64 OR ADLINK)
    set(LD80BITS OFF CACHE BOOL "")
    set(NOALIGN OFF CACHE BOOL "")
    set(ARM_DYNAREC ON CACHE BOOL "")
    set(RV64_DYNAREC OFF CACHE BOOL "")
    set(LARCH64_DYNAREC OFF CACHE BOOL "")
endif()
if(RK3399 OR ODROIDN2 OR RPI3ARM64 OR RPI4ARM64 OR RPI5ARM64)
    set(SAVE_MEM ON CACHE BOOL "")
endif()
if(RK3588)
    set(BAD_SIGNAL ON CACHE BOOL "")
endif()
if(SW64)
    set(LD80BITS OFF CACHE BOOL "")
    set(NOALIGN OFF CACHE BOOL "")
endif()
if(ANDROID)
    set(TERMUX_PATH "/data/data/com.termux/files")
    #set(NOLOADADDR ON CACHE BOOL "")  #no need to force this setting it seems now
    set(BAD_SIGNAL ON CACHE BOOL "")
endif()

if(GDBJIT)
    message(STATUS "Build with GDBJIT support")
    add_definitions(-DGDBJIT)
endif()

option(LD80BITS "Set to ON if host device have 80bits long double (i.e. i386)" ${LD80BITS})
option(NOALIGN "Set to ON if host device doesn't need re-align (i.e. i386)" ${NOALIGN})
option(ARM_DYNAREC "Set to ON to use ARM Dynamic Recompilation" ${ARM_DYNAREC})
option(RV64_DYNAREC "Set to ON to use RISC-V Dynamic Recompilation" ${RV64_DYNAREC})
option(LARCH64_DYNAREC "Set to ON to use LOONGARCH64 Dynamic Recompilation" ${LARCH64_DYNAREC})
option(STATICBUILD "Set to ON to have a static build (Warning, not working)" ${STATICBUILD})
option(NO_LIB_INSTALL "Set ON to not install a few x86_64 libs that are used by many program" ${NO_LIB_INSTALL})
option(NO_CONF_INSTALL "Set ON to not install config files" ${NO_CONF_INSTALL})

if(${CMAKE_VERSION} VERSION_LESS "3.12.2")
    find_package(PythonInterp 3)
    if(NOT PYTHONINTERP_FOUND)
        message( FATAL_ERROR "You need a Python interpreter, CMake will exit." )
    endif()
    if(${PYTHON_VERSION_MAJOR} LESS 3)
        message( FATAL_ERROR "You need a Python 3 interpreter, CMake will exit." )
    endif()
else()
    find_package(Python3)
    if(NOT Python3_Interpreter_FOUND)
        message( FATAL_ERROR "You need a Python interpreter, CMake will exit." )
    endif()
    set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE} CACHE INTERNAL "The Python3 executable" FORCE)
endif()

project(box64 C ASM)

enable_testing()

set(default_build_type "RelWithDebInfo")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if(RPI3ARM64)
    add_definitions(-DRPI)
    add_definitions(-DRPI3ARM64)
    set(CFLAGS -pipe -march=armv8-a+crc -mtune=cortex-a53)
elseif(RPI4ARM64)
    add_definitions(-DRPI)
    add_definitions(-DRPI4ARM64)
    set(CFLAGS -pipe -march=armv8-a+crc -mtune=cortex-a72)
elseif(RPI5ARM64)
    add_definitions(-DRPI)
    add_definitions(-DRPI5ARM64)
    set(CFLAGS -pipe -march=armv8.2-a+crc+crypto+fp16+rcpc+dotprod -mtune=cortex-a76)
elseif(RK3326)
    add_definitions(-DRK3326)
    set(CFLAGS -pipe -march=armv8-a+crc+simd+crypto -mcpu=cortex-a35+crypto)
elseif(RK3399)
    add_definitions(-DRK3399)
    set(CFLAGS -pipe -march=armv8-a+crc+simd+crypto -mcpu=cortex-a72.cortex-a53+crypto)
elseif(RK3588)
    add_definitions(-DRK3588)
    add_definitions(-DBAD_SIGNAL)
    set(CFLAGS -pipe -mcpu=cortex-a76.cortex-a55+crypto)
elseif(ODROIDN2)
    add_definitions(-DODROIDN2)
    set(CFLAGS -march=armv8-a+crc+simd+crypto -mcpu=cortex-a73.cortex-a53+crypto)
elseif(TEGRAX1)
    add_definitions(-DTEGRAX1)
    set(CFLAGS -pipe -march=armv8-a+crc+simd+crypto -mcpu=cortex-a57+crypto)
elseif(TEGRA_T194)
    add_definitions(-DTEGRA_T194)
    set(CFLAGS -pipe -march=armv8.2-a+fp16+simd+crypto+predres -mcpu=cortex-a76+crypto -mtune=cortex-a76)
elseif(TEGRA_T234)
    add_definitions(-DTEGRA_T234)
    set(CFLAGS -pipe -march=armv8.2-a+fp16+simd+crypto+predres -mcpu=cortex-a78ae+crypto -mtune=cortex-a78ae)
elseif(PHYTIUM)
    add_definitions(-DPHYTIUM)
    set(CFLAGS -pipe -march=armv8.1-a+crc+simd+crypto)
elseif(SD845)
    add_definitions(-DSD845)
    set(CFLAGS -pipe -march=armv8.2-a+simd+crypto -mtune=cortex-a75.cortex-a55)
elseif(SD865)
    add_definitions(-DSD865)
    #note that cortex-a77.cortex-a55 is not supported, so fall back to a76 instead
    set(CFLAGS -pipe -march=armv8.2-a+simd+crypto -mtune=cortex-a76.cortex-a55)
elseif(SD888)
    add_definitions(-DSD888)
    set(CFLAGS -pipe -march=armv8.4-a+simd+crypto)
elseif(SD8G2)
    add_definitions(-DSD8G2)
    set(CFLAGS -pipe -march=armv9-a+i8mm+sm4+sha3+rcpc+crypto+nosve+nosve2)
elseif(SDORYON1)
    add_definitions(-DSDORYON1)
    # NOTE
    #
    # 1.
    # GCC 14 and Clang 19 support oryon-1 as a -mcpu/-mtune argument,
    # however it seems like fedora (the system I tested this on) does not work.
    # see https://gcc.gnu.org/onlinedocs/gcc-14.2.0/gcc/AArch64-Options.html if you're interested
    #
    # 2.
    # gcc/gcc/config/aarch64/aarch64-cores.def:157 defines oryon1 as
    # AARCH64_CORE("oryon-1", oryon1, cortexa57, V8_6A, (CRYPTO, SM4, SHA3, F16), cortexa72,   0x51, 0x001, -1)
    # where
    #  * the 3rd positional argument is represented as the "scheduler"
    #  * the 6th positional argument is represented as the "cost"
    #  I've chosen the a57 because I don't know if I should choose the a72
    set(CFLAGS -pipe -march=armv8.6-a+crypto+sm4+sha3+fp16 -mtune=cortex-a57)
elseif(ADLINK)
    add_definitions(-DADLINK)
    set(CFLAGS -pipe -mcpu=neoverse-n1 -fuse-ld=gold -fuse-linker-plugin)
elseif(M1)
    add_definitions(-DM1)
    set(CFLAGS -pipe -march=armv8.5-a+simd+crypto)
elseif(LARCH64)
    add_definitions(-DLA64)
    set(CFLAGS -pipe -march=loongarch64)
    set(ASMFLAGS  -pipe -march=loongarch64)
elseif(RV64)
    add_definitions(-DRV64)
    set(CFLAGS -pipe -march=rv64gc)
    set(ASMFLAGS  -pipe -march=rv64gc)
elseif(PPC64LE)
    add_definitions(-DPPC64LE)
elseif(LX2160A)
    add_definitions(-DLX2160A)
    set(CFLAGS -pipe -march=armv8-a+crypto+crc -mcpu=cortex-a72+crypto)
elseif(SW64)
    add_definitions(-DSW64)
elseif(ARM64)
    #add_definitions(-pipe -march=native)
endif()
if(ARM_DYNAREC)
    if (CMAKE_C_COMPILER_ID STREQUAL "GNU" AND CMAKE_C_COMPILER_VERSION VERSION_LESS "9.0")
        set(ASMFLAGS  -pipe -march=armv8.2-a+crc+simd+crypto)
    else()
        #putting a random cpu that have 8.2 architecture so assembly can be build. the use of the feature are conditionnal anyway
        set(ASMFLAGS  -pipe -mcpu=cortex-a76)
    endif()
endif()
if(ANDROID)
    add_definitions(-DANDROID)
endif()
if(TERMUX)
    add_definitions(-DTERMUX)
endif()
if(WINLATOR_GLIBC)
    add_definitions(-DWINLATOR_GLIBC)
endif()
if(BAD_SIGNAL)
    add_definitions(-DBAD_SIGNAL)
endif()
if(SAVE_MEM)
    add_definitions(-DSAVE_MEM)
endif()
if(STATICBUILD)
    #-fno-pic -mcmodel=large
    add_definitions(-DSTATICBUILD)
    add_definitions(-Wno-deprecated-declarations)   #by-design, deprecated function can be used
    set(BUILD_SHARED_LIBS OFF)
    set(CMAKE_EXE_LINKER_FLAGS -static)
    set(HAVE_TRACE OFF)
endif()
if(BOX32)

=== wine/wow64/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(wowbox64 C ASM)

if(${CMAKE_VERSION} VERSION_LESS "3.12.2")
    find_package(PythonInterp 3)
    if(NOT PYTHONINTERP_FOUND)
        message( FATAL_ERROR "You need a Python interpreter, CMake will exit." )
    endif()
    if(${PYTHON_VERSION_MAJOR} LESS 3)
        message( FATAL_ERROR "You need a Python 3 interpreter, CMake will exit." )
    endif()
else()
    find_package(Python3)
    if(NOT Python3_Interpreter_FOUND)
        message( FATAL_ERROR "You need a Python interpreter, CMake will exit." )
    endif()
    set(PYTHON_EXECUTABLE ${Python3_EXECUTABLE} CACHE INTERNAL "The Python3 executable" FORCE)
endif()

set(BOX64_ROOT "${CMAKE_SOURCE_DIR}/../..")

string(REPLACE "," ";" DYNAREC_ASM "${DYNAREC_ASM_STR}")
string(REPLACE "," ";" DYNAREC_PASS "${DYNAREC_PASS_STR}")
string(REPLACE "," ";" INTERPRETER "${INTERPRETER_STR}")

set(WOW64_MAIN_SRC
    "${BOX64_ROOT}/wine/common/crt.c"
    "${BOX64_ROOT}/wine/common/wrt.c"
    "${BOX64_ROOT}/wine/wow64/wowbox64.c"
)

set(MUSL_SRC
    "${BOX64_ROOT}/external/musl/__cos.c"
    "${BOX64_ROOT}/external/musl/__math_divzero.c"
    "${BOX64_ROOT}/external/musl/__math_invalid.c"
    "${BOX64_ROOT}/external/musl/__rem_pio2_large.c"
    "${BOX64_ROOT}/external/musl/__rem_pio2.c"
    "${BOX64_ROOT}/external/musl/__sin.c"
    "${BOX64_ROOT}/external/musl/cos.c"
    "${BOX64_ROOT}/external/musl/exp_data.c"
    "${BOX64_ROOT}/external/musl/exp2.c"
    "${BOX64_ROOT}/external/musl/expm1.c"
    "${BOX64_ROOT}/external/musl/frexp.c"
    "${BOX64_ROOT}/external/musl/ldexp.c"
    "${BOX64_ROOT}/external/musl/log1p.c"
    "${BOX64_ROOT}/external/musl/log2_data.c"
    "${BOX64_ROOT}/external/musl/log2.c"
    "${BOX64_ROOT}/external/musl/scalbn.c"
    "${BOX64_ROOT}/external/musl/sin.c"
    "${BOX64_ROOT}/external/musl/sincos.c"
    "${BOX64_ROOT}/external/musl/sqrt_data.c"
    "${BOX64_ROOT}/external/musl/sqrt.c"
    "${BOX64_ROOT}/external/musl/sqrtf.c"
)

set_source_files_properties(${DYNAREC_ASM} PROPERTIES COMPILE_OPTIONS "-mcpu=cortex-a76")

foreach(STEP_VALUE RANGE 3)
    add_library(wow64_dynarec_pass${STEP_VALUE} OBJECT ${DYNAREC_PASS})
    target_compile_definitions(wow64_dynarec_pass${STEP_VALUE} PRIVATE STEP=${STEP_VALUE})
endforeach()

add_library(wow64_test_interpreter OBJECT ${INTERPRETER})
set_target_properties(wow64_test_interpreter PROPERTIES COMPILE_DEFINITIONS "TEST_INTERPRETER")

set(WOW64_BOX64CPU_SRC
    "${BOX64_ROOT}/src/build_info.c"
    "${BOX64_ROOT}/src/custommem.c"
    "${BOX64_ROOT}/src/dynarec/arm64/arm64_immenc.c"
    "${BOX64_ROOT}/src/dynarec/arm64/arm64_printer.c"
    "${BOX64_ROOT}/src/dynarec/arm64/dynarec_arm64_arch.c"
    "${BOX64_ROOT}/src/dynarec/arm64/dynarec_arm64_functions.c"
    "${BOX64_ROOT}/src/dynarec/arm64/dynarec_arm64_jmpnext.c"
    "${BOX64_ROOT}/src/dynarec/arm64/dynarec_arm64_consts.c"
    "${BOX64_ROOT}/src/dynarec/arm64/updateflags_arm64.c"
    "${BOX64_ROOT}/src/dynarec/dynablock.c"
    "${BOX64_ROOT}/src/dynarec/dynarec_native_functions.c"
    "${BOX64_ROOT}/src/dynarec/dynarec_native.c"
    "${BOX64_ROOT}/src/dynarec/dynarec.c"
    "${BOX64_ROOT}/src/dynarec/dynacache_reloc.c"
    "${BOX64_ROOT}/src/emu/x64compstrings.c"
    "${BOX64_ROOT}/src/emu/x64emu.c"
    "${BOX64_ROOT}/src/emu/x64primop.c"
    "${BOX64_ROOT}/src/emu/x64shaext.c"
    "${BOX64_ROOT}/src/emu/x64test.c"
    "${BOX64_ROOT}/src/emu/x64trace.c"
    "${BOX64_ROOT}/src/emu/x64run_private.c"
    "${BOX64_ROOT}/src/emu/x87emu_private.c"
    "${BOX64_ROOT}/src/os/backtrace.c"
    "${BOX64_ROOT}/src/os/os_wine.c"
    "${BOX64_ROOT}/src/os/hostext_common.c"
    "${BOX64_ROOT}/src/os/hostext_wine.c"
    "${BOX64_ROOT}/src/os/freq_wine.c"
    "${BOX64_ROOT}/src/os/symbolfuncs_wine.c"
    "${BOX64_ROOT}/src/os/emit_signal_wine.c"
    "${BOX64_ROOT}/src/os/perfmap.c"
    "${BOX64_ROOT}/src/os/my_cpuid_wine.c"
    "${BOX64_ROOT}/src/os/my_cpuid_common.c"
    "${BOX64_ROOT}/src/tools/alternate.c"
    "${BOX64_ROOT}/src/tools/env.c"
    "${BOX64_ROOT}/src/tools/rbtree.c"
)

add_library(wowbox64 SHARED ${WOW64_MAIN_SRC} ${MUSL_SRC} ${WOW64_BOX64CPU_SRC} ${INTERPRETER} ${DYNAREC_ASM}
    $<TARGET_OBJECTS:wow64_dynarec_pass0>
    $<TARGET_OBJECTS:wow64_dynarec_pass1>
    $<TARGET_OBJECTS:wow64_dynarec_pass2>
    $<TARGET_OBJECTS:wow64_dynarec_pass3>
    $<TARGET_OBJECTS:wow64_test_interpreter>
    "${BOX64_ROOT}/wine/wow64/wowbox64.def")

include_directories(
    "${BOX64_ROOT}/src/include"
    "${BOX64_ROOT}/src"
    "${BOX64_ROOT}/wine/include"
    "${BOX64_ROOT}/external/musl"
    "${BOX64_ROOT}/external/musl/internal"
)

set(DLLTOOL aarch64-w64-mingw32-dlltool)

function(import_dll name)
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${name}.a
        COMMAND ${DLLTOOL} 
            -D ${name}.dll
            -d ${BOX64_ROOT}/wine/${name}.def
            -l ${CMAKE_CURRENT_BINARY_DIR}/${name}.a
            -k
        DEPENDS ${BOX64_ROOT}/wine/${name}.def
        COMMENT "Generating import library ${name}.a from ${name}.def"
    )
    add_custom_target(generate_${name}_import_lib DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${name}.a)
    add_dependencies(wowbox64 generate_${name}_import_lib)
    target_link_libraries(wowbox64 PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/${name}.a)
endfunction()


import_dll(ntdll)
import_dll(wow64)

# always enable DynaRec, only supports ARM64 for now.
add_compile_definitions(DYNAREC ARM64)

target_compile_options(wowbox64 PRIVATE -Wno-inconsistent-dllimport)
target_link_options(wowbox64 PRIVATE -nostdlib -nodefaultlibs 
    -lclang_rt.builtins-aarch64
    -Wl,--image-base,0x004c0000
    -Wl,/ignore:4217 # LNK4217: locally defined symbol imported
)
set_target_properties(wowbox64 PROPERTIES
    PREFIX ""
    SUFFIX ".dll"
    OUTPUT_NAME "wowbox64"
)

add_custom_command(
    TARGET wowbox64 POST_BUILD
    COMMAND "${PYTHON_EXECUTABLE}" ${CMAKE_SOURCE_DIR}/../override_wine_builtin.py $<TARGET_FILE:wowbox64>
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

=== debian/changelog ===
box64 (0.3.8+dfsg-1) unstable; urgency=medium

  * New upstream version 0.3.8
  * debian/copyright: exclude tests/misc/gclosure and tests/test32
  * debian/copyright: exclude auto-generated documentation
  * debian/*.examples: install install_steam.sh as an example script
  * debian/*.install: install box32.conf into /usr/lib/binfmt.d
  * debian/*.examples: install box64-bundle-x86-libs.sh as an example script
  * debian/*.docs: fix X64WINE.md->WINE.md and add BUNDLE-X86-LIBS.md
  * debian/control,debian/tests/control: wrap-and-sort -astb
  * add patch to fix typos
  * debian/rules: build docs/USAGE.md and docs/box64.pod

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Sun, 19 Oct 2025 03:29:45 +0200

=== debian/control ===
Source: box64
Section: utils
Priority: optional
Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 cmake,
 ninja-build,
 python3:native,
Standards-Version: 4.6.2
Homepage: https://github.com/ptitSeb/box64
Vcs-Browser: https://salsa.debian.org/debian/box64
Vcs-Git: https://salsa.debian.org/debian/box64.git
Rules-Requires-Root: no

Package: box64
Architecture: arm64 ppc64el riscv64
Depends:
 libgcc-s1:amd64 | libgcc-s1-amd64-cross,
 libstdc++6:amd64 | libstdc++6-amd64-cross,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 box64-rk3588,
 box64-rpi4,
Description: run amd64 binaries on arm64 without emulating library calls
 Using DynaRec on arm64, box64 will dynamically recompile x64_64 code to
 aarch64 but will also translate calls to foreign library functions to
 native library calls. This usually makes amd64 executables run via
 box64 much faster than emulating amd64 on arm64 via qemu which will
 emulate everything down to the C library. For example OpenArena emulated
 with box64 will be at about 85% of its native speed.
 .
 This package contains the generic executable without optimization for a
 specific platform.

Package: box64-rk3588
Architecture: arm64
Depends:
 libgcc-s1:amd64 | libgcc-s1-amd64-cross,
 libstdc++6:amd64 | libstdc++6-amd64-cross,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 box64,
 box64-rpi4,
Description: run amd64 binaries on RK3588 without emulating library calls
 Using DynaRec on arm64, box64 will dynamically recompile x64_64 code to
 aarch64 but will also translate calls to foreign library functions to
 native library calls. This usually makes amd64 executables run via
 box64 much faster than emulating amd64 on arm64 via qemu which will
 emulate everything down to the C library. For example OpenArena emulated
 with box64 will be at about 85% of its native speed.
 .
 This package is optimized with -mcpu=cortex-a76.cortex-a55+crypto and
 built with workaround for incoherent si_info on SIGSEGV.

Package: box64-rpi4
Architecture: arm64
Depends:
 libgcc-s1:amd64 | libgcc-s1-amd64-cross,
 libstdc++6:amd64 | libstdc++6-amd64-cross,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 box64,
 box64-rk3588,
Description: run amd64 binaries on RPI4 without emulating library calls
 Using DynaRec on arm64, box64 will dynamically recompile x64_64 code to
 aarch64 but will also translate calls to foreign library functions to
 native library calls. This usually makes amd64 executables run via
 box64 much faster than emulating amd64 on arm64 via qemu which will
 emulate everything down to the C library. For example OpenArena emulated
 with box64 will be at about 85% of its native speed.
 .
 This package is optimized with -march=armv8-a+crc -mtune=cortex-a72.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# for DEB_HOST_ARCH
include /usr/share/dpkg/architecture.mk
# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake+ninja

ifeq ($(DEB_HOST_ARCH),amd64)
PLATFORMS=NOALIGN
else ifeq ($(DEB_HOST_ARCH),arm64)
PLATFORMS=ARM_DYNAREC RPI4ARM64 RK3588
else ifeq ($(DEB_HOST_ARCH),ppc64el)
PLATFORMS=PPC64LE
else ifeq ($(DEB_HOST_ARCH),riscv64)
PLATFORMS=RV64
endif

override_dh_auto_configure:
	set -exu; for p in $(PLATFORMS); do dh_auto_configure --builddirectory=build.$${p} -- -D$${p}=1 -DNOGIT=1 -DNO_LIB_INSTALL=1 -DBOX32=1 -DBOX32_BINFMT=1; done

override_dh_auto_build:
	# build docs/USAGE.md and docs/box64.pod
	env --chdir=docs/gen python3 ./gen.py
	pod2man --center "Manual" --release "box64 $(DEB_VERSION_UPSTREAM)" docs/box64.pod > docs/box64.1
	mkdir -p src/wrapped/generated
	set -exu; for p in $(PLATFORMS); do dh_auto_build --builddirectory=build.$${p}; done

override_dh_auto_install:
	set -exu; for p in $(PLATFORMS); do dh_auto_install --builddirectory=build.$${p} --destdir=debian/tmp.$${p}; done

override_dh_auto_clean:
	set -exu; for p in $(PLATFORMS); do dh_auto_clean --builddirectory=build.$${p}; done
	rm -f docs/box64.1 docs/USAGE.md docs/box64.pod

# https://github.com/ptitSeb/box64/issues/648
override_dh_auto_test:

=== debian/tests/control ===
Test-Command: box64 --version
Depends:
 box64,
Restrictions:
 allow-stderr,
 superficial,
